'''This module provides the list of known configurations that can be used
throughout the application.

Automatically generated using the following:
python -c "import adhawkapi.trackermodel; adhawkapi.trackermodel.main()" -o adhawkapi

'''

BLOB = 'blob'
BLOB_SPEC = 'blob/spec'
BLOB_SPEC_REV = 'blob/spec/rev'
BLOB_SPEC_REV_AUTOTUNE = 'blob/spec/rev/autotune'
BLOB_SPEC_REV_DYNAMIC_FUSION = 'blob/spec/rev/dynamic_fusion'
BLOB_SPEC_REV_MODEL_ET = 'blob/spec/rev/model_et'
BLOB_SPEC_REV_MODEL_PRIORS = 'blob/spec/rev/model_priors'
BLOB_SPEC_REV_GEOMETRY = 'blob/spec/rev/geometry'
BLOB_TUNING = 'blob/tuning'
BLOB_TUNING_MULTIGLINT = 'blob/tuning/multiglint'
BLOB_TUNING_MODULE_CAL = 'blob/tuning/module_cal'
BLOB_TUNING_AUTOTUNE_MULTIGLINT = 'blob/tuning/autotune_multiglint'
BLOB_USER = 'blob/user'
BLOB_USER_CALIBRATION = 'blob/user/calibration'
GENERAL = 'general'
GENERAL_APIVERSION = 'general/apiversion'
GENERAL_FIRMWAREVERSION = 'general/firmwareversion'
GENERAL_NUMTRACKERS = 'general/numtrackers'
GENERAL_ACTIVEEYES = 'general/activeeyes'
METRICS = 'metrics'
METRICS_FLASH_ERASE_COUNT = 'metrics/flash_erase_count'
METRICS_FLASH_WRITE_COUNT = 'metrics/flash_write_count'
METRICS_LIFETIME_COUNTER = 'metrics/lifetime_counter'
EYETRACKER = 'eyetracker'
EYETRACKER_PUPIL_OFFSET = 'eyetracker/pupil_offset'
EYETRACKER_PCCR_ENABLE = 'eyetracker/pccr_enable'
EYETRACKER_REALTIME_Z_ENABLE = 'eyetracker/realtime_z_enable'
SPEC = 'spec'
SPEC_PRODUCT_ID = 'spec/product_id'
SPEC_BOARD_TYPE = 'spec/board_type'
SPEC_SERIAL_NUM = 'spec/serial_num'
SPEC_SHARED_DETECTOR_CAPABILITY = 'spec/shared_detector_capability'
SPEC_DEVICE_TUNE_VERSION = 'spec/device_tune_version'
SPEC_DEVICE_TUNE_DATE = 'spec/device_tune_date'
TRACKER_SPECS = 'specs'
TRACKER_SPECS_XMIN = 'specs/xmin'
TRACKER_SPECS_XMAX = 'specs/xmax'
TRACKER_SPECS_YMIN = 'specs/ymin'
TRACKER_SPECS_YMAX = 'specs/ymax'
TRACKER_SPECS_MAX_LASER_CURRENT = 'specs/max_laser_current'
TRACKER_LASERCURRENTPCT = 'lasercurrentpct'
TRACKER_LASERCURRENT = 'lasercurrent'
TRACKER_MODULATIONFREQUENCY = 'modulationfrequency'
TRACKER_MODULATIONDUTYCYCLE = 'modulationdutycycle'
TRACKER_FREQUENCY = 'frequency'
TRACKER_YFREQUENCY = 'yfrequency'
TRACKER_XRESONANCEFREQUENCY = 'xresonancefrequency'
TRACKER_YRESONANCEFREQUENCY = 'yresonancefrequency'
TRACKER_XPHASE = 'xphase'
TRACKER_YPHASE = 'yphase'
TRACKER_GLINTPWFILTERTHRESHOLD = 'glintpwfilterthreshold'
TRACKER_GLINTPWFILTERTHRESHOLD_MIN = 'glintpwfilterthreshold/min'
TRACKER_GLINTPWFILTERTHRESHOLD_MAX = 'glintpwfilterthreshold/max'
TRACKER_PUPILPWFILTERTHRESHOLD = 'pupilpwfilterthreshold'
TRACKER_PUPILPWFILTERTHRESHOLD_MIN = 'pupilpwfilterthreshold/min'
TRACKER_PUPILPWFILTERTHRESHOLD_MAX = 'pupilpwfilterthreshold/max'
TRACKER_XMEAN = 'xmean'
TRACKER_XMEAN_PCT = 'xmean_pct'
TRACKER_YMEAN = 'ymean'
TRACKER_YMEAN_PCT = 'ymean_pct'
TRACKER_WIDTH = 'width'
TRACKER_WIDTH_PCT = 'width_pct'
TRACKER_HEIGHT = 'height'
TRACKER_HEIGHT_PCT = 'height_pct'
TRACKER_XDEADTIME = 'xdeadtime'
TRACKER_YDEADTIME = 'ydeadtime'
TRACKER_DEADTIMEMODE = 'deadtimemode'
TRACKER_METRICS = 'metrics'
TRACKER_METRICS_LIFETIME_RUNNING_COUNTER = 'metrics/lifetime_running_counter'
TRACKER_OPERATIONAL = 'operational'
TRACKER_OPERATIONAL_XPHASE = 'operational/xphase'
TRACKER_OPERATIONAL_YPHASE = 'operational/yphase'
TRACKER_EYE_MODEL = 'eye_model'
TRACKER_EYE_MODEL_POS_X = 'eye_model/pos_x'
TRACKER_EYE_MODEL_POS_Y = 'eye_model/pos_y'
TRACKER_EYE_MODEL_POS_Z = 'eye_model/pos_z'
TRACKER_DEADTIME_ENABLE = 'deadtime_enable'
TRACKER_COMPONENT_OFFSET_X = 'component_offset_x'
TRACKER_COMPONENT_OFFSET_Y = 'component_offset_y'
TRACKER_COMPONENT_OFFSET_Z = 'component_offset_z'
TRACKER_SUBWINDOWING_ENABLE = 'subwindowing_enable'
TRACKER_SUBWINDOWING_X_MIN = 'subwindowing_x_min'
TRACKER_SUBWINDOWING_Y_MIN = 'subwindowing_y_min'
TRACKER_SUBWINDOWING_X_MAX = 'subwindowing_x_max'
TRACKER_SUBWINDOWING_Y_MAX = 'subwindowing_y_max'
PD_ENABLE = 'enable'
PD_GAIN = 'gain'
PD_GAINBOOST = 'gainboost'
PD_ENABLE = 'enable'
PD_GAIN = 'gain'
PD_GAINBOOST = 'gainboost'
PD_DETECTORTYPE = 'detectortype'
PD_GLINTENABLE = 'glintenable'
PD_PUPILENABLE = 'pupilenable'
PD_COMMONGAIN = 'commongain'
PD_GLINTGAIN = 'glintgain'
PD_PUPILGAIN = 'pupilgain'
AUTOTUNE = 'autotune'
AUTOTUNE_XRANGE = 'autotune/xrange'
AUTOTUNE_XRANGE_MIN = 'autotune/xrange/min'
AUTOTUNE_XRANGE_MAX = 'autotune/xrange/max'
AUTOTUNE_XRANGE_STEP = 'autotune/xrange/step'
AUTOTUNE_YRANGE = 'autotune/yrange'
AUTOTUNE_YRANGE_MIN = 'autotune/yrange/min'
AUTOTUNE_YRANGE_MAX = 'autotune/yrange/max'
AUTOTUNE_YRANGE_STEP = 'autotune/yrange/step'
AUTOTUNE_LARGE_MEGALISA_SUBWINDOW_X_MIN = 'autotune/large_megalisa_subwindow_x_min'
AUTOTUNE_LARGE_MEGALISA_SUBWINDOW_X_MAX = 'autotune/large_megalisa_subwindow_x_max'
AUTOTUNE_LARGE_MEGALISA_SUBWINDOW_Y_MIN = 'autotune/large_megalisa_subwindow_y_min'
AUTOTUNE_LARGE_MEGALISA_SUBWINDOW_Y_MAX = 'autotune/large_megalisa_subwindow_y_max'
AUTOTUNE_NOMINAL_SUBWINDOW_X_MIN = 'autotune/nominal_subwindow_x_min'
AUTOTUNE_NOMINAL_SUBWINDOW_X_MAX = 'autotune/nominal_subwindow_x_max'
AUTOTUNE_NOMINAL_SUBWINDOW_Y_MIN = 'autotune/nominal_subwindow_y_min'
AUTOTUNE_NOMINAL_SUBWINDOW_Y_MAX = 'autotune/nominal_subwindow_y_max'
AUTOTUNE_ENABLEDIAG = 'autotune/enablediag'
AUTOTUNE_ALGORITHM = 'autotune/algorithm'
AUTOTUNE_ALGORITHM_STEP1 = 'autotune/algorithm_step1'
AUTOTUNE_ALGORITHM_STEP2 = 'autotune/algorithm_step2'
AUTOTUNE_LARGE_MEGALISA_XPHASE = 'autotune/large_megalisa_xphase'
AUTOTUNE_LARGE_MEGALISA_YPHASE = 'autotune/large_megalisa_yphase'
AUTOTUNE_NOMINAL_X_MIN = 'autotune/nominal_x_min'
AUTOTUNE_NOMINAL_X_MAX = 'autotune/nominal_x_max'
AUTOTUNE_NOMINAL_Y_MIN = 'autotune/nominal_y_min'
AUTOTUNE_NOMINAL_Y_MAX = 'autotune/nominal_y_max'
