'''
Automatically generated using:
python register_generator.py --format PYTHON_DEFS --output adhawkapi/register_spec_defs.py
'''


# pylint: disable=too-many-lines
SPEC_DEFS = {
    'general1': {
        'name': 'General 1',
        'bank': 253,
        'registers': {
            'api_version': {
                'name': 'API Version',
                'register': 0,
                'write_access': False,
                'default': [0, 0],
                'type': 'uint',
                'parts': [
                    {'name': 'Minor', 'offset': 0, 'length': 16},
                    {'name': 'Major', 'offset': 16, 'length': 16},
                ],
            },
            'multi_devices': {
                'name': 'Multi-Device',
                'register': 1,
                'type': 'uint',
                'default': [0, 0, 0],
                'parts': [
                    {'name': 'Number of devices', 'offset': 0, 'length': 8},
                    {'name': 'Device id offset', 'offset': 8, 'length': 8},
                    {'name': 'Number of trackers', 'offset': 16, 'length': 8},
                ],
            },
            'laser_current': {
                'name': 'VCSEL Current (mA)',
                'register': 10,
                'default': 0,
                'validators': {'range': {'min_val': 0.0, 'max_val': 45.5}},
                'transformers': {'quantize': {'max_val': 45.5, 'num_bits': 12}},
            },
            'raw_adc': {'name': 'Raw ADC', 'register': 11},
            'configured_x_frequency': {
                'name': 'Configured X Resonant Frequency (Hz)',
                'register': 12,
                'type': 'int',
                'default': 2500,
                'validators': {'range': {'min_val': 1000, 'max_val': 10000}},
            },
            'modulation_frequency': {
                'name': 'VCSEL Frequency (mHz)',
                'register': 24,
                'validators': {'range': {'min_val': 1.0, 'max_val': 10.0}},
                'transformers': {'metric': {'multiplier': 1000000}},
            },
            'modulation_duty_cycle': {
                'name': 'VCSEL Duty Cycle (%)',
                'register': 25,
                'validators': {'range': {'min_val': 0, 'max_val': 100}},
            },
            'configured_y_frequency': {
                'name': 'Configured Y Resonant frequency(Hz)',
                'register': 27,
                'type': 'int',
                'default': 2500,
                'validators': {'range': {'min_val': 1000, 'max_val': 10000}},
            },
            'pd_config_status': {
                'name': 'PD config status',
                'version': '0.103.0',
                'register': 28,
                'default': [0, 1, 2, 3, 4, 5, 6, 7],
                'type': 'uint',
                'transformers': {
                    'bitfield': {
                        'choices': {
                            0: 'pd0',
                            1: 'pd1',
                            2: 'pd2',
                            3: 'pd3',
                            4: 'pd4',
                            5: 'pd5',
                            6: 'pupilpd0',
                            7: 'pupilpd1',
                        }
                    }
                },
            },
            'x_phase': {
                'name': 'X Phase',
                'register': 30,
                'transformers': {'quantize': {'max_val': 180, 'num_bits': 12}},
            },
            'y_phase': {
                'name': 'Y Phase',
                'register': 31,
                'transformers': {'quantize': {'max_val': 180, 'num_bits': 12}},
            },
            'pd_enable': {
                'name': 'Photodiode Enable',
                'register': 32,
                'default': [0, 1, 2, 3, 4, 5],
                'type': 'uint',
                'transformers': {
                    'bitfield': {
                        'choices': {
                            0: 'pd0',
                            1: 'pd1',
                            2: 'pd2',
                            3: 'pd3',
                            4: 'pd4',
                            5: 'pd5',
                        }
                    }
                },
            },
            'pd0_gain': {'name': 'Photodiode 1 Gain', 'register': 33},
            'pd1_gain': {'name': 'Photodiode 2 Gain', 'register': 34},
            'pd2_gain': {'name': 'Photodiode 3 Gain', 'register': 35},
            'pd3_gain': {'name': 'Photodiode 4 Gain', 'register': 36},
            'pd4_gain': {'name': 'Photodiode 5 Gain', 'register': 37},
            'pd5_gain': {'name': 'Photodiode 6 Gain', 'register': 38},
            'glint_pw_filter_max_threshold': {
                'name': 'Glint Pulse Width Filter Max Threshold',
                'register': 39,
            },
            'glint_pw_filter_min_threshold': {
                'name': 'Glint Pulse Width Filter Min Threshold',
                'register': 40,
            },
            'pd_gain_boost': {
                'name': 'Photodiode Gain Boost',
                'register': 41,
                'default': [0, 1, 2, 3, 4, 5],
                'type': 'uint',
                'transformers': {
                    'bitfield': {
                        'choices': {
                            0: 'pd0',
                            1: 'pd1',
                            2: 'pd2',
                            3: 'pd3',
                            4: 'pd4',
                            5: 'pd5',
                        }
                    }
                },
            },
            'pupil_offset': {
                'name': 'Pupil Offset',
                'register': 45,
                'type': 'float',
                'default': 10.5,
                'validators': {'range': {'min_val': 8, 'max_val': 15}},
            },
            'pupil_pw_filter_max_threshold': {
                'name': 'Pupil Pulse Width Filter Max Threshold',
                'register': 46,
            },
            'pupil_pw_filter_min_threshold': {
                'name': 'Pupil Pulse Width Filter Min Threshold',
                'register': 47,
            },
            'operational_x_frequency': {
                'name': 'Operation X resonant frequency (Hz)',
                'version': '0.19.0',
                'register': 48,
                'type': 'float',
                'default': 2500,
                'write_access': False,
                'validators': {'range': {'min_val': 1000, 'max_val': 10000}},
            },
            'operational_y_frequency': {
                'name': 'Operation Y resonant frequency (Hz)',
                'version': '0.19.0',
                'register': 49,
                'type': 'float',
                'default': 2500,
                'write_access': False,
                'validators': {'range': {'min_val': 1000, 'max_val': 10000}},
            },
            'pupilpd_enable': {
                'name': 'Pupil Detector Enable',
                'version': '0.21.0',
                'register': 50,
                'default': [0, 1, 2],
                'type': 'uint',
                'transformers': {
                    'bitfield': {
                        'choices': {0: 'pupilpd0', 1: 'pupilpd1', 2: 'pupilpd2'}
                    }
                },
            },
            'pupilpd0_gain': {
                'name': 'Pupil Detector 1 Gain',
                'version': '0.21.0',
                'register': 51,
                'default': [25, 1],
                'type': 'uint',
                'parts': [
                    {'name': 'Gain value', 'offset': 0, 'length': 16},
                    {'name': 'Gain boost', 'offset': 16, 'length': 1},
                ],
            },
            'pupilpd1_gain': {
                'name': 'Pupil Detector 2 Gain',
                'version': '0.21.0',
                'register': 52,
                'default': [25, 1],
                'type': 'uint',
                'parts': [
                    {'name': 'Gain value', 'offset': 0, 'length': 16},
                    {'name': 'Gain boost', 'offset': 16, 'length': 1},
                ],
            },
            'dead_time_x': {
                'name': 'Dead Time X',
                'version': '0.23.0',
                'register': 53,
                'validators': {'range': {'min_val': 0, 'max_val': 100}},
            },
            'dead_time_y': {
                'name': 'Dead Time Y',
                'version': '0.23.0',
                'register': 54,
                'validators': {'range': {'min_val': 0, 'max_val': 100}},
            },
            'dead_time_mode': {
                'name': 'Dead Time Mode',
                'version': '0.24.0',
                'register': 55,
                'default': 0,
                'transformers': {
                    'selection': {
                        'choices': {
                            0: 'No Dead Time',
                            1: 'Constant Time Half Cycle Max',
                            2: 'Constant Time Full Cycle Max',
                        }
                    }
                },
            },
            'operational_x_phase': {
                'name': 'Operational X Phase',
                'register': 56,
                'version': '0.27.0',
                'transformers': {'quantize': {'max_val': 180, 'num_bits': 12}},
            },
            'operational_y_phase': {
                'name': 'Operational Y Phase',
                'register': 57,
                'version': '0.27.0',
                'transformers': {'quantize': {'max_val': 180, 'num_bits': 12}},
            },
            'glint_and_pupil_pd0_gains': {
                'name': 'Shared Detector 1 Gains',
                'register': 58,
                'version': '0.34.0',
                'default': [0, 0, 0],
                'type': 'uint',
                'parts': [
                    {'name': 'Common', 'offset': 0, 'length': 4},
                    {'name': 'Glint', 'offset': 4, 'length': 4},
                    {'name': 'Pupil', 'offset': 8, 'length': 4},
                ],
            },
            'glint_and_pupil_pd1_gains': {
                'name': 'Shared Detector 2 Gains',
                'register': 59,
                'version': '0.34.0',
                'default': [0, 0, 0],
                'type': 'uint',
                'parts': [
                    {'name': 'Common', 'offset': 0, 'length': 4},
                    {'name': 'Glint', 'offset': 4, 'length': 4},
                    {'name': 'Pupil', 'offset': 8, 'length': 4},
                ],
            },
            'glint_and_pupil_pd2_gains': {
                'name': 'Shared Detector 3 Gains',
                'register': 60,
                'version': '0.34.0',
                'default': [0, 0, 0],
                'type': 'uint',
                'parts': [
                    {'name': 'Common', 'offset': 0, 'length': 4},
                    {'name': 'Glint', 'offset': 4, 'length': 4},
                    {'name': 'Pupil', 'offset': 8, 'length': 4},
                ],
            },
            'pd_state': {
                'name': 'Photodiode States',
                'register': 64,
                'version': '0.103.0',
                'type': 'uint',
                'write_access': False,
                'default': [],
                'transformers': {
                    'bitfield': {
                        'choices': {
                            0: 'pd0_e',
                            1: 'pd1_e',
                            2: 'pd2_e',
                            3: 'pd3_e',
                            4: 'pd4_e',
                            5: 'pd5_e',
                            6: 'pupilpd0_e',
                            7: 'pupilpd1_e',
                            16: 'pd0_d',
                            17: 'pd1_d',
                            18: 'pd2_d',
                            19: 'pd3_d',
                            20: 'pd4_d',
                            21: 'pd5_d',
                            22: 'pupilpd0_d',
                            23: 'pupilpd1_d',
                        }
                    }
                },
            },
            'mcu_sleep_enable': {
                'name': 'MCU Sleep Enable',
                'register': 65,
                'type': 'uint',
                'version': '0.41.0',
                'default': 0,
                'range': {'min_val': 0, 'max_val': 1},
            },
            'power_cycling_period': {
                'name': 'Power cycling period (ms)',
                'register': 66,
                'version': '0.41.0',
                'default': 100,
                'validators': {'range': {'min_val': 0, 'max_val': 10000}},
            },
            'power_cycling_duty': {
                'name': 'Power cycling on time duty cycle (percent)',
                'register': 67,
                'version': '0.41.0',
                'default': 100,
                'validators': {'range': {'min_val': 0, 'max_val': 100}},
            },
            'mcu_low_power_clock_enable': {
                'name': 'MCU low power clock Enable',
                'register': 68,
                'type': 'uint',
                'version': '0.42.0',
                'default': 0,
                'range': {'min_val': 0, 'max_val': 1},
            },
            'mcu_clock': {
                'name': 'MCU clock',
                'write_access': False,
                'register': 69,
                'type': 'uint',
                'version': '0.42.0',
                'default': 0,
            },
            'pccr_enable': {
                'name': 'PCCR Enable',
                'write_access': True,
                'register': 70,
                'type': 'uint',
                'version': '0.43.0',
                'default': 1,
            },
            'usb_hub_mode': {
                'name': 'USB HUB mode',
                'register': 71,
                'version': '0.52.0',
                'default': 0,
                'transformers': {
                    'selection': {'choices': {0: 'Hub mode', 1: 'Bypass Mode'}}
                },
            },
            'lifetime_counter': {
                'name': 'Lifetime Counter',
                'register': 72,
                'type': 'uint',
                'version': '0.53.0',
                'default': 0,
            },
            'lifetime_counter_running': {
                'name': 'Running Lifetime Counter',
                'register': 73,
                'type': 'uint',
                'version': '0.53.0',
                'default': 0,
            },
            'pd0_control': {
                'name': 'PD0 Control',
                'version': '0.55.0',
                'register': 74,
                'default': 0,
                'type': 'uint',
                'validators': {'range': {'min_val': 0, 'max_val': 16383}},
            },
            'component_offset_x': {
                'name': 'Component Offset X',
                'version': '0.56.0',
                'register': 75,
                'default': 0,
                'type': 'float',
            },
            'component_offset_y': {
                'name': 'Component Offset Y',
                'version': '0.56.0',
                'register': 76,
                'default': 0,
                'type': 'float',
            },
            'component_offset_z': {
                'name': 'Component Offset Z',
                'version': '0.56.0',
                'register': 77,
                'default': 0,
                'type': 'float',
            },
            'sub_windowing_enable': {
                'name': 'Sub Windowing Enable',
                'version': '0.70.0',
                'register': 78,
                'type': 'uint',
                'default': 0,
                'validators': {'range': {'min_val': 0, 'max_val': 1}},
            },
            'sub_windowing_x_min': {
                'name': 'Sub Windowing X Min',
                'version': '0.102.0',
                'register': 79,
                'type': 'float',
                'default': 0,
                'validators': {'range': {'min_val': -1, 'max_val': 1}},
            },
            'sub_windowing_y_min': {
                'name': 'Sub Windowing Y Min',
                'version': '0.102.0',
                'register': 80,
                'type': 'float',
                'default': 0,
                'validators': {'range': {'min_val': -1, 'max_val': 1}},
            },
            'realtime_z_enable': {
                'name': 'Realtime Z Enable',
                'write_access': True,
                'register': 81,
                'type': 'uint',
                'version': '0.93.0',
                'default': 1,
            },
            'model_eye_position_x': {
                'name': 'Model Eye Position X',
                'version': '0.98.0',
                'register': 82,
                'default': 0,
                'write_access': False,
                'type': 'float',
            },
            'model_eye_position_y': {
                'name': 'Model Eye Position Y',
                'version': '0.98.0',
                'register': 83,
                'default': 0,
                'write_access': False,
                'type': 'float',
            },
            'model_eye_position_z': {
                'name': 'Model Eye Position Z',
                'version': '0.98.0',
                'register': 84,
                'default': 0,
                'write_access': False,
                'type': 'float',
            },
            'sub_windowing_x_max': {
                'name': 'Sub Windowing X Max',
                'version': '0.102.0',
                'register': 85,
                'default': 0,
                'type': 'float',
                'validators': {'range': {'min_val': -1, 'max_val': 1}},
            },
            'sub_windowing_y_max': {
                'name': 'Sub Windowing Y Max',
                'version': '0.102.0',
                'register': 86,
                'default': 0,
                'type': 'float',
                'validators': {'range': {'min_val': -1, 'max_val': 1}},
            },
        },
    },
    'general2': {
        'name': 'General 2',
        'bank': 255,
        'registers': {
            'reset': {'name': 'Toggle Bootloader', 'register': 0, 'read_access': False},
            'start': {'name': 'Start Application', 'register': 1, 'read_access': False},
            'stop': {'name': 'Stop Application', 'register': 2, 'read_access': False},
            'wipe': {'name': 'Wipe Settings', 'register': 3, 'read_access': False},
            'flush': {'name': 'Store Settings', 'register': 4, 'read_access': False},
            'reload': {
                'name': 'Reload Application',
                'register': 5,
                'read_access': False,
            },
            'tracker_status': {
                'name': 'Tracker Status',
                'register': 7,
                'version': '0.63.0',
                'write_access': False,
                'default': [],
                'type': 'uint',
                'transformers': {
                    'bitfield': {
                        'choices': {
                            0: 'Laser Self Test Fault',
                            1: 'Laser Overcurrent Fault',
                            2: 'Laser Monitor Fault',
                            3: 'Power Mode Watchdog',
                            4: 'File Corruption Fault',
                        }
                    }
                },
            },
            'flash_write_count': {
                'name': 'Flash Write Count',
                'version': '0.79.0',
                'write_access': False,
                'register': 8,
                'type': 'uint',
                'default': 0,
            },
            'flash_erase_count': {
                'name': 'Flash Erase Count',
                'version': '0.79.0',
                'write_access': False,
                'register': 9,
                'type': 'uint',
                'default': 0,
            },
            'laser_status': {
                'name': 'Laser Status',
                'register': 10,
                'version': '0.95.0',
                'write_access': False,
                'default': [],
                'type': 'uint',
                'transformers': {
                    'bitfield': {
                        'choices': {
                            0: 'Laser Self Test Warning',
                            1: 'Laser Overcurrent Warning',
                            2: 'Laser Monitor Warning',
                        }
                    }
                },
            },
            'erase_file': {
                'name': 'Erase File',
                'register': 11,
                'version': '0.97.0',
                'read_access': False,
                'type': 'uint',
                'transformers': {
                    'selection': {
                        'choices': {
                            0: 'Settings File',
                            1: 'Blob File',
                            2: 'Autosave File',
                            3: 'Fault File',
                        }
                    }
                },
            },
            'rebuild_records_table': {
                'name': 'Rebuild Records Table',
                'register': 12,
                'version': '0.97.0',
                'read_access': False,
            },
            'vcsel_self_test': {
                'name': 'vcsel Self Test',
                'register': 13,
                'version': '0.105.0',
                'write_access': False,
                'transformers': {
                    'selection': {
                        'choices': {
                            0: 'Laser Self Test Passed',
                            1: 'Laser Self Test Not Supported',
                            2: 'Laser Self Test Fault Already Raised',
                            3: 'Laser Self Test Failed',
                        }
                    }
                },
            },
        },
    },
    'isp': {
        'name': 'ISP',
        'bank': 252,
        'registers': {
            'set_programming_mode': {'name': 'Set Programming Mode', 'register': 0},
            'version': {'name': 'Version', 'register': 1, 'write_access': False},
            'board_type': {
                'name': 'Board Type',
                'register': 2,
                'write_access': False,
                'default': 0,
                'type': 'uint',
                'transformers': {
                    'selection': {
                        'choices': {
                            0: 'DevboardV1',
                            1: 'V3Dac',
                            2: 'V3Pwm',
                            3: 'V4Dac',
                            4: 'DevboardV2',
                            5: 'DigiBrd',
                            6: 'DevboardV3',
                            7: 'SPIAdapter',
                            8: 'ComBrd',
                            9: 'VibraniumComBrd',
                            10: 'HybridV1',
                            11: 'Vibranium',
                            12: 'STDevShield',
                            13: 'CopperHub',
                            14: 'CopperFacePlate',
                            15: 'SamsungHub',
                            16: 'CopperEyeTube',
                            17: 'SamsungV1',
                            18: 'EVK3',
                            19: 'EVK3Hub',
                            20: 'BinocularHybridV1',
                            21: 'BinocularHybridHubV1',
                            22: 'Copper427Hub',
                            23: 'EVK3_1',
                            24: 'SamsungV2',
                            25: 'FPGADevboardV1',
                            26: 'SPIAdapterV2',
                            27: 'PccrEyeTrackerV1',
                            28: 'PccrPupilV1',
                            29: 'PccrHubV1',
                            30: 'BinocularHybridV2',
                            31: 'BinocularHybridHubV2',
                            32: 'STM32SPIAdapter',
                            33: 'SingleMCUV1',
                            35: 'DevboardV4',
                            36: 'SingleMCU3PD',
                            37: 'STL5DevShieldV1',
                            38: 'AHSM3ET',
                            39: 'AHSM3SPIAdapter',
                            40: 'AHSM3_3PD',
                            41: 'DevboardV4_3PD',
                            42: 'L5_EVK_V1',
                            43: 'L5_EVK_V1_3PD',
                            44: 'DevboardV5',
                            45: 'ZAPATA_V1',
                            46: 'EVK4',
                            48: 'DevboardV5_ALC',
                            49: 'L5_EVK_SR21',
                            50: 'AMBON_SHIELD',
                            51: 'L5_EVK_SR21_IRIS',
                            52: 'DevboardV6',
                            53: 'INT_V1',
                            54: 'INT_V1_IRIS',
                            55: 'MERLIN22',
                            56: 'LP_INT_V2',
                            57: 'EVK4_V2',
                            4294967295: 'VirtualClient',
                        }
                    }
                },
            },
            'checksum': {'name': 'Checksum', 'register': 3, 'write_access': False},
            'inactive_image': {
                'name': 'Inactive Image',
                'register': 4,
                'write_access': False,
            },
            'set_stable_image': {
                'name': 'Set Stable Image',
                'register': 5,
                'read_access': False,
            },
            'bootloader_version': {
                'name': 'Bootloader Version',
                'register': 6,
                'version': '0.47.0',
                'write_access': False,
            },
            'flush_buffer': {
                'name': 'Flush Buffer',
                'register': 7,
                'version': '0.51.0',
                'read_access': False,
            },
            'read_error': {
                'name': 'Read Error',
                'register': 8,
                'version': '0.51.0',
                'write_access': False,
            },
            'target_isp_version': {
                'name': 'Target ISP Version',
                'register': 9,
                'version': '0.69.0',
            },
            'target_build_id': {
                'name': 'Target Build ID',
                'register': 10,
                'version': '0.69.0',
            },
            'status': {'name': 'Status', 'register': 11, 'version': '0.90.0'},
            'safe_mode': {
                'name': 'Safe Mode',
                'register': 12,
                'version': '0.92.0',
                'validators': {'range': {'min_val': 0, 'max_val': 1}},
            },
            'reset_mcu': {
                'name': 'Reset MCU',
                'register': 13,
                'version': '0.97.0',
                'read_access': False,
            },
        },
    },
    'spec': {
        'name': 'Spec',
        'bank': 254,
        'registers': {
            'product_category': {
                'name': 'Product Category',
                'register': 0,
                'write_access': False,
                'transformers': {
                    'selection': {
                        'choices': {0: 'Other', 1: 'HMD', 5: 'Single Tracker'}
                    }
                },
            },
            'capability': {
                'name': 'Device Capability',
                'register': 1,
                'type': 'uint',
                'default': [],
                'write_access': False,
                'transformers': {
                    'bitfield': {
                        'choices': {
                            0: 'Eye Tracker',
                            1: 'Right Eye',
                            2: 'Left Eye',
                            9: 'Embedded Frontend',
                            11: 'Embedded ET',
                            12: 'Pupil Tracker',
                            15: 'Shared Detector Capability',
                            16: 'Single Tracker Optimization',
                            17: 'Direct Detector Control',
                            18: 'Laser Safety Bypass',
                            19: 'Fundamental Drive',
                        }
                    }
                },
            },
            'camera': {
                'name': 'Camera Type',
                'register': 2,
                'type': 'uint',
                'default': 0,
                'transformers': {
                    'selection': {
                        'choices': {
                            0: 'Not_Available',
                            1: 'SMI',
                            2: 'SMI_INV',
                            3: 'Quanta',
                            4: 'Quanta_INV',
                            5: 'Quanta2',
                            6: 'Quanta2_INV',
                            7: 'Sincere',
                        }
                    }
                },
            },
            'device_tune_version': {
                'name': 'Device Tune Version',
                'version': '0.73.0',
                'register': 3,
                'type': 'uint',
                'default': 0,
            },
            'device_tune_date': {
                'name': 'Device Tune Date',
                'version': '0.73.0',
                'register': 4,
                'type': 'uint',
                'default': 0,
            },
            'build': {
                'name': 'Build Number',
                'register': 10,
                'type': 'str',
                'size': 8,
                'write_access': False,
            },
            'serial_number': {
                'name': 'Serial Number',
                'register': 20,
                'type': 'str',
                'size': 8,
                'write_access': False,
            },
            'x_max': {
                'name': 'X Max',
                'register': 30,
                'write_access': False,
                'transformers': {'linearnorm': {}},
            },
            'x_min': {
                'name': 'X Min',
                'register': 31,
                'write_access': False,
                'transformers': {'linearnorm': {}},
            },
            'y_max': {
                'name': 'Y Max',
                'register': 32,
                'write_access': False,
                'transformers': {'linearnorm': {}},
            },
            'y_min': {
                'name': 'Y Min',
                'register': 33,
                'write_access': False,
                'transformers': {'linearnorm': {}},
            },
            'max_vcsel_current': {
                'name': 'Max Laser Current',
                'register': 35,
                'write_access': False,
                'validators': {'range': {'min_val': 0.0, 'max_val': 45.5}},
                'transformers': {'quantize': {'max_val': 45.5, 'num_bits': 12}},
            },
            'max_duty_cycle': {
                'name': 'Max Duty Cycle',
                'register': 36,
                'write_access': False,
            },
            'scanner_orientation': {
                'name': 'Scanner Orientation',
                'register': 37,
                'write_access': False,
                'version': '0.22.0',
                'default': [],
                'transformers': {
                    'bitfield': {
                        'choices': {0: 'SwappedXY', 1: 'FlippedX', 2: 'FlippedY'}
                    }
                },
            },
            'product_id': {
                'name': 'Product Id',
                'register': 38,
                'write_access': True,
                'version': '0.24.0',
                'default': 0,
                'transformers': {
                    'selection': {
                        'choices': {
                            0: 'Unknown',
                            1: 'EXPERIMENTAL',
                            2: 'AHSM',
                            3: 'CUOAP',
                            4: 'EVK3P1',
                            5: 'EVK3P2',
                            6: 'EVK3P4',
                            7: 'GARC5',
                            8: 'GTK',
                            9: 'AHSM2',
                            10: 'EVK3P5',
                            11: 'SWALLOW',
                            12: 'AHSM3A1',
                            13: 'AHSM3A2',
                            14: 'SPARROW',
                            15: 'EVK3P6',
                            16: 'EVK4P0',
                            17: 'GANNET',
                            18: 'SparrowG3',
                            19: 'EVK3P6G3',
                            20: 'AHSM3J',
                            21: 'MFGBench',
                            22: 'MFGBenchG3',
                            23: 'AHSM3A1MOCKUP',
                            24: 'AHSM3A2MOCKUP',
                            25: 'AHSM3K',
                            26: 'EVK5P0',
                            27: 'AHSM3KL',
                            28: 'ZAPATA',
                            29: 'HWBench',
                            30: 'HOBBY',
                            31: 'EVK4P1',
                            32: 'DARTER',
                            33: 'SR21A',
                            34: 'SR21B',
                            35: 'AMBON_SHIELD',
                            36: 'SWALLOW21',
                            37: 'SR21C',
                            38: 'FALCON21_V5',
                            39: 'ALBATROSS21',
                            40: 'FALCON21',
                            41: 'MINDLINK_2P5MM',
                            42: 'MFGBench_LONGEVITY',
                            43: 'MERLIN22',
                            44: 'FALCON21_3GPD',
                            46: 'DARTERFOLDED3P2',
                            47: 'FALCON2',
                            48: 'MERLIN2',
                        }
                    }
                },
            },
            'scanner_fault_reaction': {
                'name': 'Scanner Fault Reaction',
                'register': 39,
                'version': '0.28.0',
                'default': 1,
            },
            'pd_order': {
                'name': 'PD Order',
                'register': 44,
                'type': 'uint',
                'write_access': False,
                'version': '0.30.0',
                'default': 0,
            },
            'pd_type': {
                'name': 'PD Type',
                'register': 45,
                'type': 'uint',
                'write_access': False,
                'version': '0.34.0',
                'default': 0,
            },
            'res_freq_x': {
                'name': 'Resonance Frequency X',
                'register': 47,
                'type': 'uint',
                'version': '0.37.0',
                'default': 0,
            },
            'res_freq_y': {
                'name': 'Resonance Frequency Y',
                'register': 48,
                'type': 'uint',
                'version': '0.37.0',
                'default': 0,
            },
            'ocular_mode': {
                'name': 'Ocular Mode',
                'version': '0.49.0',
                'register': 49,
                'default': 3,
                'transformers': {
                    'selection': {'choices': {1: 'Right', 2: 'Left', 3: 'Binocular'}}
                },
            },
            'x1_resistance_cal_multiplier': {
                'name': 'Actuator X1 Resistance Calibration Multiplier',
                'register': 52,
                'type': 'float',
                'version': '0.81.0',
                'default': 1,
            },
            'x1_resistance_cal_offset': {
                'name': 'Actuator X1 Resistance Calibration Offset',
                'register': 53,
                'type': 'float',
                'version': '0.81.0',
                'default': 0,
            },
            'x2_resistance_cal_multiplier': {
                'name': 'Actuator X2 Resistance Calibration Multiplier',
                'register': 54,
                'type': 'float',
                'version': '0.81.0',
                'default': 1,
            },
            'x2_resistance_cal_offset': {
                'name': 'Actuator X2 Resistance Calibration Offset',
                'register': 55,
                'type': 'float',
                'version': '0.81.0',
                'default': 0,
            },
            'y1_resistance_cal_multiplier': {
                'name': 'Actuator Y1 Resistance Calibration Multiplier',
                'register': 56,
                'type': 'float',
                'version': '0.81.0',
                'default': 1,
            },
            'y1_resistance_cal_offset': {
                'name': 'Actuator Y1 Resistance Calibration Offset',
                'register': 57,
                'type': 'float',
                'version': '0.81.0',
                'default': 0,
            },
            'y2_resistance_cal_multiplier': {
                'name': 'Actuator Y2 Resistance Calibration Multiplier',
                'register': 58,
                'type': 'float',
                'version': '0.81.0',
                'default': 1,
            },
            'y2_resistance_cal_offset': {
                'name': 'Actuator Y2 Resistance Calibration Offset',
                'register': 59,
                'type': 'float',
                'version': '0.81.0',
                'default': 0,
            },
            'vcsel_forward_voltage_cal_multiplier': {
                'name': 'VCSEL Forward Voltage Calibration Multiplier',
                'register': 60,
                'type': 'float',
                'version': '0.81.0',
                'default': 1,
            },
            'vcsel_forward_voltage_cal_offset': {
                'name': 'VCSEL Forward Voltage Calibration Offset',
                'register': 61,
                'type': 'float',
                'version': '0.81.0',
                'default': 0,
            },
            'resonance_cal_multiplier': {
                'name': 'Resonance Calibration Multiplier',
                'register': 62,
                'type': 'float',
                'version': '0.81.0',
                'default': 1,
            },
            'resonance_cal_offset': {
                'name': 'Resonance Calibration Offset',
                'register': 63,
                'type': 'float',
                'version': '0.81.0',
                'default': 0,
            },
            'optical_power_main_cal_multiplier': {
                'name': 'Optical Power Main Channel Calibration Multiplier',
                'register': 64,
                'type': 'float',
                'version': '0.81.0',
                'default': 1,
            },
            'optical_power_main_cal_offset': {
                'name': 'Optical Power Main Channel Calibration Offset',
                'register': 65,
                'type': 'float',
                'version': '0.81.0',
                'default': 0,
            },
            'optical_power_bg_cal_multiplier': {
                'name': 'Optical Power BG Channel Calibration Multiplier',
                'register': 66,
                'type': 'float',
                'version': '0.81.0',
                'default': 1,
            },
            'optical_power_bg_cal_offset': {
                'name': 'Optical Power BG Channel Calibration Offset',
                'register': 67,
                'type': 'float',
                'version': '0.81.0',
                'default': 0,
            },
            'vcsel_drive_cal_multiplier': {
                'name': 'VCSEL Drive Calibration Multiplier',
                'register': 68,
                'type': 'float',
                'version': '0.81.0',
                'default': 1,
            },
            'vcsel_drive_cal_offset': {
                'name': 'VCSEL Drive Calibration Offset',
                'register': 69,
                'type': 'float',
                'version': '0.81.0',
                'default': 0,
            },
            'adc_reference_voltage': {
                'name': 'ADC Reference Voltage',
                'register': 70,
                'type': 'uint',
                'version': '0.86.0',
                'default': 0,
                'write_access': False,
            },
            'vcsel_forward_voltage_gain': {
                'name': 'VCSEL Forward Voltage Gain',
                'register': 71,
                'type': 'float',
                'version': '0.94.0',
                'default': 1.0,
                'write_access': False,
            },
            'board_serial_number': {
                'name': 'Board Serial Number',
                'register': 72,
                'size': 4,
                'type': 'bytes',
                'version': '0.96.0',
                'write_access': False,
            },
            'vcsel_safety_threshold': {
                'name': 'VCSEL Safety Threshold',
                'register': 76,
                'type': 'float',
                'version': '0.105.0',
                'write_access': False,
            },
        },
    },
    'debug': {
        'name': 'DEBUG',
        'bank': 251,
        'registers': {
            'config_gpio': {
                'name': 'Config GPIO',
                'register': 0,
                'version': '0.61.0',
                'read_access': False,
                'default': [0, 0],
                'type': 'uint',
                'parts': [
                    {
                        'name': 'Mode',
                        'offset': 0,
                        'length': 1,
                        'transformers': {
                            'selection': {'choices': {0: 'Input', 1: 'Output'}}
                        },
                    },
                    {'name': 'Index', 'offset': 1, 'length': 4},
                ],
            },
            'write_gpio': {
                'name': 'Write GPIO',
                'register': 1,
                'version': '0.61.0',
                'read_access': False,
                'default': [0, 0],
                'type': 'uint',
                'parts': [
                    {
                        'name': 'Level',
                        'offset': 0,
                        'length': 1,
                        'transformers': {
                            'selection': {'choices': {0: 'Low', 1: 'High'}}
                        },
                    },
                    {'name': 'Index', 'offset': 1, 'length': 4},
                ],
            },
            'read_gpio': {
                'name': 'Read GPIO',
                'register': 2,
                'version': '0.61.0',
                'write_access': False,
                'default': 0,
                'type': 'uint',
            },
            'set_pwm': {
                'name': 'Set PWM',
                'register': 3,
                'version': '0.66.0',
                'read_access': False,
                'default': [0, 0],
                'type': 'uint',
                'parts': [
                    {
                        'name': 'axis',
                        'offset': 0,
                        'length': 8,
                        'transformers': {
                            'selection': {
                                'choices': {
                                    0: 'X1_AXIS',
                                    1: 'X2_AXIS',
                                    2: 'Y1_AXIS',
                                    3: 'Y2_AXIS',
                                }
                            }
                        },
                    },
                    {
                        'name': 'pwm percent',
                        'offset': 8,
                        'length': 8,
                        'range': {'min_val': 0, 'max_val': 100},
                    },
                ],
            },
            'set_rm_enable': {
                'name': 'Enable Resonance Measurement Mode',
                'register': 4,
                'version': '0.106.0',
                'read_access': False,
                'default': 0,
                'type': 'uint',
                'range': {'min_val': 0, 'max_val': 1},
            },
        },
    },
    'megalisa': {
        'name': 'Megalisa',
        'bank': 5,
        'registers': {
            'y_max': {
                'name': 'Y Max',
                'register': 0,
                'default': 1023,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'y_min': {
                'name': 'Y Min',
                'register': 1,
                'default': 0,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'x_max': {
                'name': 'X Max',
                'register': 2,
                'default': 1023,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'x_min': {
                'name': 'X Min',
                'register': 3,
                'default': 0,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'stream_enable': {
                'name': 'Stream Enable',
                'version': '0.38.0',
                'register': 4,
                'default': 1,
                'validators': {'range': {'min_val': 0, 'max_val': 1}},
            },
        },
    },
    'autotune': {
        'name': 'Autotune',
        'bank': 7,
        'registers': {
            'x_min': {
                'name': 'X Min',
                'register': 5,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'x_max': {
                'name': 'X Max',
                'register': 6,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'x_step': {
                'name': 'X Step',
                'register': 7,
                'transformers': {'linearnorm': {}},
            },
            'y_min': {
                'name': 'Y Min',
                'register': 8,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'y_max': {
                'name': 'Y Max',
                'register': 9,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'y_step': {
                'name': 'Y Step',
                'register': 10,
                'transformers': {'linearnorm': {}},
            },
            'large_megalisa_subwindow_x_min': {
                'name': 'Large Megalisa Subwindow X Min',
                'version': '0.102.0',
                'register': 11,
                'type': 'float',
                'default': -1.0,
                'validators': {'range': {'min_val': -1.0, 'max_val': 1.0}},
            },
            'large_megalisa_subwindow_x_max': {
                'name': 'Large Megalisa Subwindow X Max',
                'version': '0.102.0',
                'register': 12,
                'type': 'float',
                'default': 1.0,
                'validators': {'range': {'min_val': -1.0, 'max_val': 1.0}},
            },
            'large_megalisa_subwindow_y_min': {
                'name': 'Large Megalisa Subwindow Y Min',
                'version': '0.102.0',
                'register': 13,
                'type': 'float',
                'default': -1.0,
                'validators': {'range': {'min_val': -1.0, 'max_val': 1.0}},
            },
            'large_megalisa_subwindow_y_max': {
                'name': 'Large Megalisa Subwindow Y Max',
                'version': '0.102.0',
                'register': 14,
                'type': 'float',
                'default': 1.0,
                'validators': {'range': {'min_val': -1.0, 'max_val': 1.0}},
            },
            'nominal_subwindow_x_min': {
                'name': 'Nominal Subwindow X Min',
                'version': '0.102.0',
                'register': 15,
                'type': 'float',
                'default': -1.0,
                'validators': {'range': {'min_val': -1.0, 'max_val': 1.0}},
            },
            'nominal_subwindow_x_max': {
                'name': 'Nominal Subwindow X Max',
                'version': '0.102.0',
                'register': 16,
                'type': 'float',
                'default': 1.0,
                'validators': {'range': {'min_val': -1.0, 'max_val': 1.0}},
            },
            'nominal_subwindow_y_min': {
                'name': 'Nominal Subwindow Y Min',
                'version': '0.102.0',
                'register': 17,
                'type': 'float',
                'default': -1.0,
                'validators': {'range': {'min_val': -1.0, 'max_val': 1.0}},
            },
            'nominal_subwindow_y_max': {
                'name': 'Nominal Subwindow Y Max',
                'version': '0.102.0',
                'register': 18,
                'type': 'float',
                'default': 1.0,
                'validators': {'range': {'min_val': -1.0, 'max_val': 1.0}},
            },
            'control': {
                'name': 'Control',
                'register': 32,
                'default': [0, 3],
                'type': 'uint',
                'parts': [
                    {'name': 'Enable Diagnostics', 'offset': 0, 'length': 1},
                    {
                        'name': 'Algorithm',
                        'offset': 1,
                        'length': 3,
                        'transformers': {
                            'selection': {
                                'choices': {
                                    0: 'Analog',
                                    1: 'Digital box sweep',
                                    2: 'Digital line sweep',
                                    3: 'Digital line sweep v2',
                                    4: 'Box sizing',
                                }
                            }
                        },
                    },
                ],
            },
            'algorithm_selection': {
                'name': 'Algorithm Selection',
                'version': '0.58.0',
                'register': 50,
                'default': [3, 0, 0, 0],
                'type': 'uint',
                'parts': [
                    {'name': 'Algorithm 1', 'offset': 0, 'length': 8},
                    {'name': 'Algorithm 2', 'offset': 8, 'length': 8},
                    {'name': 'Algorithm 3', 'offset': 16, 'length': 8},
                    {'name': 'Algorithm 4', 'offset': 24, 'length': 8},
                ],
            },
            'large_megalisa_xphase': {
                'name': 'Large Megalisa X Phase',
                'version': '0.65.0',
                'register': 51,
                'transformers': {'quantize': {'max_val': 180, 'num_bits': 12}},
            },
            'large_megalisa_yphase': {
                'name': 'Large Megalisa Y Phase',
                'version': '0.65.0',
                'register': 52,
                'transformers': {'quantize': {'max_val': 180, 'num_bits': 12}},
            },
            'nominal_x_min': {
                'name': 'X Min',
                'version': '0.72.0',
                'register': 53,
                'default': 0,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'nominal_x_max': {
                'name': 'X Max',
                'version': '0.72.0',
                'register': 54,
                'default': 1023,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'nominal_y_min': {
                'name': 'Y Min',
                'version': '0.72.0',
                'register': 55,
                'default': 0,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'nominal_y_max': {
                'name': 'Y Max',
                'version': '0.72.0',
                'register': 56,
                'default': 1023,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
        },
    },
    'analog': {
        'name': 'Analog',
        'bank': 11,
        'registers': {
            'channel_selection': {
                'name': 'Channel Selection',
                'version': '0.39.0',
                'register': 0,
                'default': 0,
                'transformers': {
                    'selection': {
                        'choices': {
                            0: 'Ringdown',
                            1: 'X1_Resistance',
                            2: 'X2_Resistance',
                            3: 'Y1_Resistance',
                            4: 'Y2_Resistance',
                            5: 'VCSEL_ForwardVoltage',
                            6: 'Spare_1',
                            7: 'Spare_2',
                            8: 'Spare_1_And_Spare_2',
                        }
                    }
                },
            },
            'sample_count': {
                'name': 'Sample Count',
                'version': '0.39.0',
                'register': 1,
                'default': 1024,
                'validators': {'range': {'min_val': 2, 'max_val': 55000}},
            },
            'settling_time': {
                'name': 'Settling Time',
                'version': '0.39.0',
                'register': 2,
                'default': 10,
                'validators': {'range': {'min_val': 0, 'max_val': 4095}},
            },
            'actuator_bias_x': {
                'name': 'Actuator Bias X',
                'deprecated': True,
                'version': '0.44.0',
                'register': 3,
                'default': 2047,
                'validators': {'range': {'min_val': 0, 'max_val': 4095}},
            },
            'vcsel_bias_current': {
                'name': 'VCSEL Bias Current',
                'version': '0.39.0',
                'register': 4,
                'default': 0,
                'validators': {'range': {'min_val': 0.0, 'max_val': 45.5}},
                'transformers': {'quantize': {'max_val': 45.5, 'num_bits': 12}},
            },
            'actuator_bias_y': {
                'name': 'Actuator Bias Y',
                'deprecated': True,
                'version': '0.44.0',
                'register': 5,
                'default': 2047,
                'validators': {'range': {'min_val': 0, 'max_val': 4095}},
            },
            'high_threshold_trigger': {
                'name': 'High Threshold Trigger',
                'version': '0.45.0',
                'register': 6,
                'default': 4095,
                'validators': {'range': {'min_val': 0, 'max_val': 4095}},
            },
            'low_threshold_trigger': {
                'name': 'Low Threshold Trigger',
                'version': '0.45.0',
                'register': 7,
                'default': 0,
                'validators': {'range': {'min_val': 0, 'max_val': 4095}},
            },
            'observer_window_size': {
                'name': 'Observer Window Size',
                'version': '0.45.0',
                'register': 8,
                'default': 100,
                'validators': {'range': {'min_val': 1, 'max_val': 1000}},
            },
            'megasample_enable': {
                'name': 'Megasample Enable',
                'version': '0.45.0',
                'register': 9,
                'default': 0,
                'validators': {'range': {'min_val': 0, 'max_val': 1}},
            },
            'lissajous_enable': {
                'name': 'Lissajous Enable',
                'deprecated': True,
                'version': '0.46.0',
                'register': 10,
                'default': 0,
                'validators': {'range': {'min_val': 0, 'max_val': 1}},
            },
            'y_max': {
                'name': 'Y Max',
                'version': '0.46.0',
                'register': 11,
                'default': 520,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'y_min': {
                'name': 'Y Min',
                'version': '0.46.0',
                'register': 12,
                'default': 500,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'x_max': {
                'name': 'X Max',
                'version': '0.46.0',
                'register': 13,
                'default': 520,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'x_min': {
                'name': 'X Min',
                'version': '0.46.0',
                'register': 14,
                'default': 500,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'high_threshold_trigger_2': {
                'name': 'High Threshold Trigger 2',
                'version': '0.47.0',
                'register': 15,
                'default': 4095,
                'validators': {'range': {'min_val': 0, 'max_val': 4095}},
            },
            'low_threshold_trigger_2': {
                'name': 'Low Threshold Trigger 2',
                'version': '0.47.0',
                'register': 16,
                'default': 0,
                'validators': {'range': {'min_val': 0, 'max_val': 4095}},
            },
            'sample_rate': {
                'name': 'Sample Rate',
                'version': '0.60.0',
                'register': 17,
                'default': 42000,
                'validators': {'range': {'min_val': 42000, 'max_val': 5000000}},
            },
            'sample_resolution': {
                'name': 'Sample Resolution',
                'version': '0.60.0',
                'register': 18,
                'default': 12,
                'validators': {'range': {'min_val': 8, 'max_val': 12}},
            },
            'sample_frequency': {
                'name': 'Sample Frequency',
                'version': '0.104.0',
                'register': 19,
                'default': 0,
                'type': 'uint',
                'write_access': False,
            },
        },
    },
    'analoglissajous': {
        'name': 'Analog Lissajous',
        'bank': 12,
        'registers': {
            'capture_time': {
                'name': 'Capture Time (ms)',
                'version': '0.67.0',
                'register': 0,
                'default': 50,
                'validators': {'range': {'min_val': 10, 'max_val': 1000}},
            },
            'segment_count': {
                'name': 'Segment Count',
                'version': '0.67.0',
                'register': 1,
                'default': 10,
                'validators': {'range': {'min_val': 1, 'max_val': 20}},
            },
            'sample_count': {
                'name': 'Sample Count',
                'version': '0.67.0',
                'register': 2,
                'default': 500,
                'validators': {'range': {'min_val': 1, 'max_val': 10000}},
            },
            'sample_rate': {
                'name': 'Sample Rate',
                'version': '0.67.0',
                'register': 3,
                'default': 5000000,
                'validators': {'range': {'min_val': 42000, 'max_val': 5000000}},
            },
            'y_max': {
                'name': 'Y Max',
                'version': '0.68.0',
                'register': 4,
                'default': 520,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'y_min': {
                'name': 'Y Min',
                'version': '0.68.0',
                'register': 5,
                'default': 500,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'x_max': {
                'name': 'X Max',
                'version': '0.68.0',
                'register': 6,
                'default': 520,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'x_min': {
                'name': 'X Min',
                'version': '0.68.0',
                'register': 7,
                'default': 500,
                'validators': {'range': {'min_val': 0, 'max_val': 1023}},
                'transformers': {'linearnorm': {}},
            },
            'sample_phase': {
                'name': 'Sample Phase (deg)',
                'version': '0.82.0',
                'register': 8,
                'default': 0,
                'validators': {'range': {'min_val': 0, 'max_val': 360}},
            },
            'image_width': {
                'name': 'Image Width',
                'version': '0.84.0',
                'register': 9,
                'default': 120,
                'validators': {'range': {'min_val': 100, 'max_val': 200}},
            },
            'image_correction_type': {
                'name': 'Image Correction Type',
                'version': '0.84.0',
                'register': 10,
                'default': 0,
                'transformers': {
                    'selection': {'choices': {0: 'None', 1: 'Wrap', 2: 'Cosine'}}
                },
            },
            'image_generation_algorithm': {
                'name': 'Image Generation Algorithm',
                'version': '0.84.0',
                'register': 11,
                'default': 0,
                'transformers': {
                    'selection': {
                        'choices': {0: 'One Pixel Averaging', 1: 'Four Pixel Averaging'}
                    }
                },
            },
            'startup_period': {
                'name': 'Startup Period (ms)',
                'version': '0.85.0',
                'register': 12,
                'default': 10,
                'validators': {'range': {'min_val': 0, 'max_val': 100}},
            },
            'negative_slew': {
                'name': 'Negative Slew',
                'version': '0.85.0',
                'register': 13,
                'default': -30,
                'validators': {'range': {'min_val': -255, 'max_val': 0}},
            },
            'saturation_limit_high': {
                'name': 'Saturation Limit High',
                'version': '0.85.0',
                'register': 14,
                'default': 30,
                'validators': {'range': {'min_val': 0, 'max_val': 255}},
            },
            'saturation_limit_low': {
                'name': 'Saturation Limit Low',
                'version': '0.85.0',
                'register': 15,
                'default': 30,
                'validators': {'range': {'min_val': 0, 'max_val': 255}},
            },
            'segment_forwarding': {
                'name': 'Segment Forwarding',
                'version': '0.87.0',
                'register': 16,
                'default': 0,
                'validators': {'range': {'min_val': 0, 'max_val': 1}},
            },
            'image_postprocessing': {
                'name': 'Image Postprocessing',
                'version': '0.87.0',
                'register': 17,
                'default': 0,
                'transformers': {
                    'selection': {'choices': {0: 'None', 1: 'Average', 2: 'Median'}}
                },
            },
            'x_phase_adjustment': {
                'name': 'X Phase Adjustment',
                'version': '0.88.0',
                'register': 18,
                'type': 'float',
                'default': 0,
                'validators': {'range': {'min_val': -180, 'max_val': 180}},
            },
            'y_phase_adjustment': {
                'name': 'Y Phase Adjustment',
                'version': '0.88.0',
                'register': 19,
                'type': 'float',
                'default': 0,
                'validators': {'range': {'min_val': -180, 'max_val': 180}},
            },
        },
    },
}
